#include "xbasic_types.h"
#include "xio.h"
#include "xintc_l.h"
#include "xuartlite_l.h"

//#define ALTERNATE
#define WIDTH 640
#define HEIGHT 480
#define VGA_START 0x00800000
#define ONE 0x01
#define TWO 0x02
#define THREE 0x04
#define FOUR 0x08
#define FIVE 0x10
#define SIX 0x20
#define SEVEN 0x40
#define EIGHT 0x80

#define RED    0xE0  //1110 0000
#define RISH   0xC0  //1100 0000
#define GREEN  0x1C  //0001 1100
#define GISH   0x18  //0001 1000
#define BLUE   0x03  //0000 0011
#define BISH   0x02  //0000 0010
#define YELLOW 0xFC  //1111 1100
#define YISH   0xD8  //1101 1000
#define BLACK  0     //0000 0000
#define WHITE  0xFF  //1111 1111
#define WISH   0xDA  //1101 1010
#define SIZE 24

//sine/cosines scaled to 11 bits
#define ISINVALUE   0x00000132
#define ICOSVALUE   0x000007E9
#define ISINNVALUE  0xFFFFFECE
#define ICOSNVALUE  0x000007E9

#define BUFSIZE 20
extern void uart_handler(void *callback);
extern int uart_interrupt_count;
//extern void microblaze_enable_icache();
extern void microblaze_enable_interrupts();
extern void microblaze_disable_interrupts();
extern void print(char *);
extern char uart_character;
extern char buffer[BUFSIZE]; //a circular buffer is sized to hold input data
extern char *lastin;
extern char *lastout;

void setup_interrupts();
void clear_screen();

    
    int worldMap[SIZE][SIZE]=
    {
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,2,2,2,2,2,0,0,0,0,3,0,3,0,3,0,0,0,1},
        {1,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,2,0,0,0,2,0,0,0,0,3,0,0,0,3,0,0,0,1},
        {1,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,2,2,0,2,2,0,0,0,0,3,0,3,0,3,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,4,0,4,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,4,0,0,0,0,5,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,4,0,4,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,4,0,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,4,4,4,4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
    };


			 
int main()
{

    int draw=0;
    char c;

    Xuint8 colors[11] = {0, RED, GREEN, BLUE, WHITE, YELLOW,
			 RISH,GISH, BISH, WISH, YISH};

    int posX   = 22<<16, posY   = 12<<16;
    int dirX   = -1<<16, dirY   = 0;
    int planeX = 0,      planeY = 43254; //0.66 * 2^16
    
    int rayDirX,    rayDirY, cameraX;
    int mapX, mapY, oldMapX=0, oldMapY, oldDirX, oldPlaneX;
    int lineHeight, drawStart, drawEnd, count, myColor;


//    int cameraX, rayPosX, rayPosY;
//    int rayDirX, rayDirY, mapX, mapY;
//    int oldMapX, oldMapY;
//    int count, myColor;
//    int lineHeight, drawStart, drawEnd;
    Xuint32 addr;

    int x,y;

    buffer[BUFSIZE]='\0';
    //microblaze_enable_icache();
    setup_interrupts();
    clear_screen();
    print("MAYD\r\n");
    draw=1;
    for (;;)
    {

	//GET CHARACTER FROM BUFFER, if any
	c = 0;
	microblaze_disable_interrupts();
	if (lastin != lastout)
	{

	    c=*lastout;      
	    microblaze_enable_interrupts();
	    if (lastout == buffer + BUFSIZE)
		//rollover to beginning of buffer if necessary
		lastout = buffer;
	    else
		lastout++;

	    if (c == 'w') //up
	    {
		if(worldMap[(posX + dirX/2)>>16][posY>>16] == 0)
		    posX += dirX/2;
		if(worldMap[posX>>16][(posY + dirY/2)>>16] == 0)
		    posY += dirY/2;
		draw=1;
	    }
	    else if (c == 's') //down
	    {
		if(worldMap[(posX - dirX/2)>>16][(posY)>>16] == 0)
		    posX -= dirX/2;
		if(worldMap[(posX)>>16][(posY - dirY/2)>>16] == 0)
		    posY -= dirY/2;
		draw=1;
	    }
	    else if (c == 'a') //left
	    {
		oldDirX   = dirX;
		oldPlaneX = planeX;
		dirX   = (int)(dirX      * ICOSVALUE - dirY   * ISINVALUE)>>11;
		dirY   = (int)(oldDirX   * ISINVALUE + dirY   * ICOSVALUE)>>11;
		planeX = (int)(planeX    * ICOSVALUE - planeY * ISINVALUE)>>11;
		planeY = (int)(oldPlaneX * ISINVALUE + planeY * ICOSVALUE)>>11;
		draw=1;
	    }
	    else if (c == 'd') //right
	    {
		oldDirX   = dirX;
		oldPlaneX = planeX;
		dirX   = (int)(dirX      * ICOSNVALUE - dirY   * ISINNVALUE)>>11;
		dirY   = (int)(oldDirX   * ISINNVALUE + dirY   * ICOSNVALUE)>>11;
		planeX = (int)(planeX    * ICOSNVALUE - planeY * ISINNVALUE)>>11;
		planeY = (int)(oldPlaneX * ISINNVALUE + planeY * ICOSNVALUE)>>11;
		draw=1;
	    }
	    else
	    {
		//print("Unknown character: ");
		//putnum(c);
		//print("\r\n");
	    }
	}
	else
	    microblaze_enable_interrupts();
	
	if (draw!=1)
	    continue;
	
	for(x = 0; x < WIDTH; x++)
	{
	    count = 0;
	    cameraX = x - WIDTH/2;
	    rayDirX = dirX + (planeX * cameraX) / (WIDTH/2);
	    rayDirY = dirY + (planeY * cameraX) / (WIDTH/2);
	    mapX = posX;
	    mapY = posY;
	    
	    rayDirX >>=6;
	    rayDirY >>=6;
	    while (worldMap[mapX>>16][mapY>>16] == 0)
	    {
		count++;
		oldMapY = mapY;
		oldMapX = mapX;
		mapX += rayDirX;
		mapY += rayDirY;
	    }
	    lineHeight = ((HEIGHT<<6) / count)>>0;
	    drawStart = HEIGHT / 2 - lineHeight / 2;
	    drawEnd   = HEIGHT / 2 + lineHeight / 2;
	    if(drawStart < 0)		drawStart = 0;
	    if(drawEnd   >= HEIGHT)	drawEnd   = HEIGHT - 1;	
	    
	    
	    myColor = worldMap[mapX>>16][mapY>>16];
	    if (worldMap[oldMapX>>16][mapY>>16])
	    {
		myColor+=5;
	    }
	    
	    //do actual drawing
	    addr = VGA_START + x;
	    for(y=0; y<drawStart ; y++) {
		XIo_Out8(addr     ,ONE|THREE|FIVE|SIX|SEVEN);
		addr += WIDTH;
	    }
	    for(y=drawStart; y<drawEnd ; y++) {
		XIo_Out8(addr     ,colors[myColor]);
		addr += WIDTH;
	    }
	    for(y=drawEnd; y<480 ; y++) {
		XIo_Out8(addr     ,ONE|THREE|FOUR|SIX|EIGHT);
		addr += WIDTH;
	    }
	    draw=0;
	}
    }
    return 0;
}


void setup_interrupts()
{
  XIntc_mMasterDisable(XPAR_INTC_SINGLE_BASEADDR);
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR,0);
  XIntc_mAckIntr(XPAR_INTC_SINGLE_BASEADDR, 0xffffffff);
  XIntc_InterruptVectorTable[XPAR_INTC_MYUART_INTERRUPT_INTR].Handler =
    uart_handler;
  microblaze_enable_interrupts();
  XIntc_mMasterEnable(XPAR_INTC_SINGLE_BASEADDR);
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR, XPAR_MYUART_INTERRUPT_MASK);
  XUartLite_mEnableIntr(XPAR_MYUART_BASEADDR);

}

void clear_screen()
{
  int i;
  for(i=0 ; i<HEIGHT*WIDTH ; i++)
    XIo_Out8(VGA_START + i, 0);
}
